## ---- include=FALSE---------------------------------------------------------------------------
###tags=자릿점,소수점,수,숫자,readdelim,fread,readcsv,맞춤법,ISO
###category=R,전처리,숫자,표기법
knitr::opts_chunk$set(echo = TRUE)


## ---- eval=FALSE------------------------------------------------------------------------------
## 3141592.65359
## 3141592,65359
## 3 141 592.653 59
## 3 141 592,653 59


## ----eval=FALSE-------------------------------------------------------------------------------
## 제44항 수를 적을 적에는 ‘만(萬)’ 단위로 띄어 쓴다.
##     십이억 삼천사백오십육만 칠천팔백구십팔
##     12억 3456만 7898


## ---- eval=FALSE------------------------------------------------------------------------------
## 한편, 종전 규정에는 ‘100,000원’과 같이 수의 자릿점을 나타낼 때 쉼표를 쓸 수 있다는 규정이 있었다.
## 그런데 이 용법은 개정안에서 정의한 문장 부호, 즉 문장의 구조를 드러내거나
## 글쓴이의 의도를 전달하기 위해 사용하는 부호가 아니라서 제외하였다.
## 그러나 이는 쉼표의 이런 용법이 문장 부호에 해당하지 않아서 규정에서 다루지 않는다는 것이지,
## 수의 자릿점을 나타내는 부호로 쉼표를 활용하는 것을 막는 것은 아니다.


## ---- eval=F----------------------------------------------------------------------------------
## read.csv(file=filename, dec=',') # dec = decimal mark?, decimal seperator?
## readr::read_delim(file=filename, locale=locale(decimal_mark=','))
## data.table::fread(file=filename, dec=',')


## ----eval=FALSE, include=FALSE----------------------------------------------------------------
## x <- c("1,234.22", "1,244,533")
## gsub(",", "", x)


## ----eval=FALSE, include=FALSE----------------------------------------------------------------
## ISO 31-0.
## ISO 80000-1.
## 
## <https://en.wikipedia.org/wiki/ISO_31-0> supercede by <https://en.wikipedia.org/wiki/ISO_80000-1>
## 
## <https://www.clien.net/service/board/lecture/6112919>
## 
## <https://en.wikipedia.org/wiki/ISO_31-0> supercede by <https://en.wikipedia.org/wiki/ISO_80000-1>
## 
## 
## 제43항 단위를 나타내는 명사는 띄어 쓴다.
##     한 개	차 한 대	금 서 돈	소 한 마리
##     옷 한 벌	열 살	조기 한 손	연필 한 자루
##     버선 한 죽	집 한 채	신 두 켤레	북어 한 쾌
## 
## 다만, 순서를 나타내는 경우나 숫자와 어울리어 쓰이는 경우에는 붙여 쓸 수 있다.
##     두시 삼십분 오초	제일과	삼학년
##     육층	1446년 10월 9일	2대대
##     16동 502호	제1실습실	80원
##     10개	7미터
## 
## 제44항 수를 적을 적에는 ‘만(萬)’ 단위로 띄어 쓴다.
##     십이억 삼천사백오십육만 칠천팔백구십팔
##     12억 3456만 7898
## 
## 제45항 두 말을 이어 주거나 열거할 적에 쓰이는 다음의 말들은 띄어 쓴다.
##     국장 겸 과장	열 내지 스물	청군 대 백군
##     책상, 걸상 등이 있다	이사장 및 이사들	사과, 배, 귤 등등
##     사과, 배 등속	부산, 광주 등지
## 
## 제46항 단음절로 된 단어가 연이어 나타날 적에는 붙여 쓸 수 있다.
##     좀더 큰것	이말 저말	한잎 두잎
## 
## ('한글 맞춤범, 5장 띄어쓰기' 중에서)
## 
## #### 쉼표, 수의 자릿점
## 
## 
## 한편, 종전 규정에는 ‘100,000원’과 같이 수의 자릿점을 나타낼 때 쉼표를 쓸 수 있다는 규정이 있었다. 그런데 이 용법은 개정안에서 정의한 문장 부호, 즉 문장의 구조를 드러내거나 글쓴이의 의도를 전달하기 위해 사용하는 부호가 아니라서 제외하였다. 그러나 이는 쉼표의 이런 용법이 문장 부호에 해당하지 않아서 규정에서 다루지 않는다는 것이지, 수의 자릿점을 나타내는 부호로 쉼표를 활용하는 것을 막는 것은 아니다.
## 
## ('문장부호해설' 중에서)
## 
## 

